function [ IDX ] = stegerClustering(wc,c)
%COUPLING3 This function implements an adapted version of Steger's local
% clustering algorithm.
%   wc: Whisker cells (per-pixel information about the position of a
%   centerline
%   c: c-value for weighing the influence of the angle difference
%   IDX: clustering

logical_containsWP = real(wc) > 0;                                          % Mark all the pixels that contain a centerline point
nonzeroEntries = find(logical_containsWP);                                  % Find all those pixels, get their positions
identifiers = [1:length(nonzeroEntries)]';                                  % Give each of those pixels a separate ID number.
whiskerID = gpuArray(zeros(size(wc)));                                      % Build a matrix with the size of the image, 
whiskerID(nonzeroEntries) = whiskerID(nonzeroEntries)+ ...                  % ... and put the ID numbers in the right positions
    gpuArray(identifiers);
wa = mod(wrapTo2Pi(angle(wc-round(wc))),pi)-0.5*pi;                         % Convert complex numbers into angles.                         
wa(~logical_containsWP) = 0;                                                % Set other pixels to 0
wa = wa+whiskerID*1i;                                                       % Add the ID number and the angle in the same matrix.
                                                                            % In this way, only two matrices need to be loaded to the GPU:
                                                                            % wa (containing the angles and the ID numbers);
                                                                            % wc (containing the intrapixel positions of the centerline points).
                                                                            
coupled = arrayfun(@(r1c1, r1c2, r1c3, r1c4, r1c5, ...                      % Stencil operation on the GPU to do local clustering. The pixel 'peeks' in both directions,
                     r2c1, r2c2, r2c3, r2c4, r2c5, ...                      % the variable <chosenSide> serves as a flag. 
                     r3c1, r3c2, r3c3, r3c4, r3c5, ...
                     r4c1, r4c2, r4c3, r4c4, r4c5, ...
                     r5c1, r5c2, r5c3, r5c4, r5c5, ...
                     a_r1c1, a_r1c2, a_r1c3, a_r1c4, a_r1c5, ...
                     a_r2c1, a_r2c2, a_r2c3, a_r2c4, a_r2c5, ...
                     a_r3c1, a_r3c2, a_r3c3, a_r3c4, a_r3c5, ...
                     a_r4c1, a_r4c2, a_r4c3, a_r4c4, a_r4c5, ...
                     a_r5c1, a_r5c2, a_r5c3, a_r5c4, a_r5c5, chosenSide, wad) ...
  determineNeighbor (r1c1, r1c2, r1c3, r1c4, r1c5, ...
                     r2c1, r2c2, r2c3, r2c4, r2c5, ...
                     r3c1, r3c2, r3c3, r3c4, r3c5, ...
                     r4c1, r4c2, r4c3, r4c4, r4c5, ...
                     r5c1, r5c2, r5c3, r5c4, r5c5, ...
                     a_r1c1, a_r1c2, a_r1c3, a_r1c4, a_r1c5, ...
                     a_r2c1, a_r2c2, a_r2c3, a_r2c4, a_r2c5, ...
                     a_r3c1, a_r3c2, a_r3c3, a_r3c4, a_r3c5, ...
                     a_r4c1, a_r4c2, a_r4c3, a_r4c4, a_r4c5, ...
                     a_r5c1, a_r5c2, a_r5c3, a_r5c4, a_r5c5, chosenSide, wad), ...
                     reshape(wc(1:end-4,1:end-4),[],1), reshape(wc(2:end-3,1:end-4),[],1), reshape(wc(3:end-2,1:end-4),[],1), reshape(wc(4:end-1,1:end-4),[],1), reshape(wc(5:end,1:end-4),[],1), ... 
                     reshape(wc(1:end-4,2:end-3),[],1), reshape(wc(2:end-3,2:end-3),[],1), reshape(wc(3:end-2,2:end-3),[],1), reshape(wc(4:end-1,2:end-3),[],1), reshape(wc(5:end,2:end-3),[],1), ... 
                     reshape(wc(1:end-4,3:end-2),[],1), reshape(wc(2:end-3,3:end-2),[],1), reshape(wc(3:end-2,3:end-2),[],1), reshape(wc(4:end-1,3:end-2),[],1), reshape(wc(5:end,3:end-2),[],1), ... 
                     reshape(wc(1:end-4,4:end-1),[],1), reshape(wc(2:end-3,4:end-1),[],1), reshape(wc(3:end-2,4:end-1),[],1), reshape(wc(4:end-1,4:end-1),[],1), reshape(wc(5:end,4:end-1),[],1), ... 
                     reshape(wc(1:end-4,5:end),[],1),   reshape(wc(2:end-3,5:end),[],1),   reshape(wc(3:end-2,5:end),[],1),   reshape(wc(4:end-1,5:end)  ,[],1), reshape(wc(5:end,5:end)  ,[],1), ... 
                     reshape(wa(1:end-4,1:end-4),[],1), reshape(wa(2:end-3,1:end-4),[],1), reshape(wa(3:end-2,1:end-4),[],1), reshape(wa(4:end-1,1:end-4),[],1), reshape(wa(5:end,1:end-4),[],1), ... 
                     reshape(wa(1:end-4,2:end-3),[],1), reshape(wa(2:end-3,2:end-3),[],1), reshape(wa(3:end-2,2:end-3),[],1), reshape(wa(4:end-1,2:end-3),[],1), reshape(wa(5:end,2:end-3),[],1), ... 
                     reshape(wa(1:end-4,3:end-2),[],1), reshape(wa(2:end-3,3:end-2),[],1), reshape(wa(3:end-2,3:end-2),[],1), reshape(wa(4:end-1,3:end-2),[],1), reshape(wa(5:end,3:end-2),[],1), ... 
                     reshape(wa(1:end-4,4:end-1),[],1), reshape(wa(2:end-3,4:end-1),[],1), reshape(wa(3:end-2,4:end-1),[],1), reshape(wa(4:end-1,4:end-1),[],1), reshape(wa(5:end,4:end-1),[],1), ... 
                     reshape(wa(1:end-4,5:end),[],1),   reshape(wa(2:end-3,5:end),[],1),   reshape(wa(3:end-2,5:end),[],1),   reshape(wa(4:end-1,5:end)  ,[],1), reshape(wa(5:end,5:end)  ,[],1), [0 1],c); 

                 
newCoup = [imag(reshape(wa(3:end-2,3:end-2),[],1)) coupled(:,1); ...        
    imag(reshape(wa(3:end-2,3:end-2),[],1)) coupled(:,2)];                  % Convert to to a n-by-2 matrix of pairs of IDs of pixels that contain centerline points of the same cluster
newCoup = gather(newCoup(newCoup(:,1) & newCoup(:,2),:));                   % Gather from the GPU only the entries that do not contain any zeros.
conn = sparse(newCoup(:,1),newCoup(:,2),1,identifiers(end), ...             % Create a sparse connectivity matrix
    identifiers(end));
S = conn & conn';                                                           % Retain only the connections that are two-sided.
[~, IDX] = graphconncomp(S,'Directed',false);                               % Convert connectivity matrix to clustering.

end

